(in-package :sb-heapdump)

#+(and x86 linux)
(progn
  (defvar *temporary-space-start* #x50000000)
  (defvar *temporary-space-end*   #x6fffffff))

(defconstant +n+ sb-vm:n-word-bytes)
(defconstant +2n+ (* 2 +n+))

(defstruct (header (:type vector))
  object
  fixups
  initializer)

(macrolet ((doit (&rest names)
	     `(progn
		(defvar *fixup-names* ,(coerce names 'vector))
		,@(loop
		      for name in names
		      for i from 0
		      collect `(defconstant ,name ,i)))))
  ;; order matters
  (doit +parameter-fixup+
	+package-fixup+
	+symbol-fixup+
	+classoid-fixup+
	+layout-fixup+
	+fdefn-fixup+
	+named-type-fixup+
	+array-type-fixup+
	+class-fixup+
	+function-fixup+
	+ctor-fixup+
	+slot-accessor-fixup+
	+fast-method-fixup+
	+raw-address-fixup+))

(defstruct (fixup
	    (:type vector)
	    (:constructor make-fixup (type id))
	    (:constructor make-symbol-fixup (type id2 id))
	    (:constructor make-fast-method-fixup (type id id2)))
  type
  id
  id2
  locations)
